Summary: SSL wrapper to the TCP servers
Name: sslwrap
Version: 2.02
Release: 1
Source: http://www.rickk.com/sslwrap/sslwrap.tar.gz
Patch: sslwrap-2.02-rh.patch
Copyright: Freeware
Packager: Jan "Yenya" Kasprzak <kas@fi.muni.cz>
Group: Networking/Daemons
BuildRoot: /var/tmp/sslwrap-root
Summary(cs): SSL oblka pro TCP servery
Prereq: patch

%description
The sslwrap utility is a wrapper to the TCP servers (such as imapd,
pop3d or telnetd), which can be used to add a transport-layer
encryption to these network servers using the Secure Socket Layer (SSL)
protocol. This program is linked against SSLeay, the open source,
non-US implementation of SSL.

The sources and binaries of SSLeay as well as this RPM can be downloaded
from http://www.replay.com/redhat (which is a non-US site).

%description -l cs
Program sslwrap slou jako oblka pro TCP servery (napklad imapd,
pop3d nebo telnetd). Me bt pouit pro pidn ifrovn na transportn
vrstv pro tyto server. Pouv protokol Secure Socket Layer (SSL).
Tento program je sestaven s knihovnami SSLeay, co je open-source
implementace SSL, dostupn mimo Spojen Stty.

Zdrojov i binrn RPM balky SSLeay i sslwrap mete zskat
z http://www.replay.com/redhat (co je server mimo USA).

%prep
%setup -n sslwrap202
%patch -p1 -b .rh

%build
make OPT="$RPM_OPT_FLAGS"

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/usr/sbin
install -s sslwrap ${RPM_BUILD_ROOT}/usr/sbin/sslwrap
for i in https imaps telnets pop3s
do
	ln -s sslwrap ${RPM_BUILD_ROOT}/usr/sbin/sslwrap-$i
done

%triggerin -- setup
if grep -q imaps /etc/services
then :
else
	echo "Adding SSL-wrapped servers to /etc/services." >&2
	patch -p0 -s <<'EOF'
--- /etc/services.orig	Fri Jan 15 03:59:37 1999
+++ /etc/services	Fri Jan 15 04:07:33 1999
@@ -107,6 +107,15 @@
 kerberos_master	751/udp                         # Kerberos authentication
 kerberos_master	751/tcp                         # Kerberos authentication
 krb5_prop	754/tcp                         # Kerberos slave propagation
+https		443/tcp				# http protocol over TLS/SSL
+smtps		465/tcp				# smtp protocol over TLS/SSL
+nntps		563/tcp				# nttp protocol over TLS/SSL
+telnets		992/tcp				# telnet protocol over TLS/SSL
+imaps		993/tcp				# imap4 protocol over TLS/SSL
+ircs		994/tcp				# irc protocol over TLS/SSL
+pop3s		995/tcp				# POP3 protocol over TLS/SSL
+ftps-data	989/tcp				# ftp protocol, data, over TLS/SSL
+ftps		990/tcp				# ftp protocol, control, over TL
 listen		1025/tcp	listener RFS remote_file_sharing
 nterm		1026/tcp	remote_login network_terminal
 kpop		1109/tcp                        # Pop with Kerberos
EOF
fi

%triggerin -- netkit-base
if grep -q sslwrap /etc/inetd.conf
then :
else
	echo "Adding SSL-wrapped servers to /etc/inetd.conf (uncomment to enable)." >&2
	cat <<'EOF' >>/etc/inetd.conf
#
# sslwrap - SSL-protected servers. Jan "Yenya" Kasprzak <kas@fi.muni.cz>
# You need to create a site certificate first. Use the following commands
# to create the certificate:
#
## cd /var/lib/ssl/certs
## RANDFILE=/dev/urandom req -new -x509 -nodes -out server.pem \
##      -keyout server.pem -days 365
## ln -s server.pem `x509 -noout -hash < server.pem`.0
#
# You may want to add the user "sslwrap" to your system, so that sslwrap
# does not run under root id. You can chown the server.pem to user sslwrap.
#
## useradd -c 'SSL wrapper' -d / -g daemon -s /bin/false sslwrap
## chown sslwrap /var/lib/ssl/certs/server.pem
## chmod go-rwx /var/lib/ssl/certs/server.pem
#
# I have linked sslwrap to sslwrap-<servicename> to allow each port to be
# controled by TCP wrappers separately.
#
# https stream tcp nowait sslwrap /usr/sbin/tcpd /usr/sbin/sslwrap-https -cert /var/lib/ssl/certs/server.pem -port 80
# imaps stream tcp nowait sslwrap /usr/sbin/tcpd /usr/sbin/sslwrap-imaps -cert /var/lib/ssl/certs/server.pem -port 143
# telnets stream tcp nowait sslwrap /usr/sbin/tcpd /usr/sbin/sslwrap-telnets -cert /var/lib/ssl/certs/server.pem -port 23
# pop3s stream tcp nowait sslwrap /usr/sbin/tcpd /usr/sbin/sslwrap-pop3s -cert /var/lib/ssl/certs/server.pem -port 110 
EOF
fi

%post
cat >&2 <<'EOF'

You need to create a site certificate first. Use the following commands
to create the certificate:

cd /var/lib/ssl/certs
RANDFILE=/dev/urandom req -new -x509 -nodes -out server.pem \
	-keyout server.pem -days 365
ln -s server.pem `x509 -noout -hash < server.pem`.0

You may want to add the user "sslwrap" to your system, so that sslwrap
does not run under root id. You can chown the server.pem to user sslwrap.

useradd -c 'SSL wrapper' -d / -g daemon -s /bin/false sslwrap
chown sslwrap /var/lib/ssl/certs/server.pem
chmod go-rwx /var/lib/ssl/certs/server.pem

See also the /etc/inetd.conf file for examples of usage.

EOF

%files
%defattr(-,root,root)
/usr/sbin/sslwrap
%attr(-,root,root) /usr/sbin/sslwrap-https
%attr(-,root,root) /usr/sbin/sslwrap-imaps
%attr(-,root,root) /usr/sbin/sslwrap-pop3s
%attr(-,root,root) /usr/sbin/sslwrap-telnets
%doc README docs.html
